
package net.mcreator.testmode.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.Minecraft;

import net.mcreator.testmode.world.inventory.PlayerinformationMenu;
import net.mcreator.testmode.network.PlayerinformationButtonMessage;
import net.mcreator.testmode.TestModeMod;

import java.util.HashMap;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.systems.RenderSystem;

public class PlayerinformationScreen extends AbstractContainerScreen<PlayerinformationMenu> {
	private final static HashMap<String, Object> guistate = PlayerinformationMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;

	public PlayerinformationScreen(PlayerinformationMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = new ResourceLocation("test_mode:textures/screens/playerinformation.png");

	@Override
	public void render(PoseStack ms, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(ms);
		super.render(ms, mouseX, mouseY, partialTicks);
		this.renderTooltip(ms, mouseX, mouseY);
	}

	@Override
	protected void renderBg(PoseStack ms, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		RenderSystem.setShaderTexture(0, texture);
		this.blit(ms, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
	}

	@Override
	protected void renderLabels(PoseStack poseStack, int mouseX, int mouseY) {
		this.font.draw(poseStack, "player information", 40, 17, -12829636);
		this.font.draw(poseStack, "Level", 19, 35, -12829636);
		this.font.draw(poseStack, "1", 64, 36, -12829636);
		this.font.draw(poseStack, "Class", 19, 55, -12829636);
		this.font.draw(poseStack, "undefined", 65, 55, -12829636);
	}

	@Override
	public void onClose() {
		super.onClose();
		Minecraft.getInstance().keyboardHandler.setSendRepeatsToGui(false);
	}

	@Override
	public void init() {
		super.init();
		this.minecraft.keyboardHandler.setSendRepeatsToGui(true);
		this.addRenderableWidget(new Button(this.leftPos + 57, this.topPos + 127, 61, 20, new TextComponent("classes"), e -> {
			if (true) {
				TestModeMod.PACKET_HANDLER.sendToServer(new PlayerinformationButtonMessage(0, x, y, z));
				PlayerinformationButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}));
	}
}
